from time import sleep
import RPi.GPIO as GPIO
import pygame

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD) # pinummers dus!

# nummer achter knop representeert headerpin op Raspberry Pi

knop1 = 37 # deelnemer 1
knop2 = 35 # deelnemer 2
knop3 = 29 # deelnemer 3
knop4 = 31 # deelnemer 4
knopl = 33 # programmaleider

led1 = 11 # deelnemer 1
led2 = 13 # deelnemer 2
led3 = 12 # deelnemer 3
led4 = 16 # deelnemer 4
ledl = 15 # programma wacht op input

GPIO.setup(knop1,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(knop2,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(knop3,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(knop4,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(knopl,GPIO.IN,pull_up_down=GPIO.PUD_UP)

GPIO.setup(led1,GPIO.OUT)
GPIO.setup(led2,GPIO.OUT)
GPIO.setup(led3,GPIO.OUT)
GPIO.setup(led4,GPIO.OUT)
GPIO.setup(ledl,GPIO.OUT)

def led1_aan():
    "Deelnemer 1 heeft als eerste gedrukt"
    GPIO.output(led1,GPIO.HIGH)
    GPIO.output(led2,GPIO.LOW)
    GPIO.output(led3,GPIO.LOW)
    GPIO.output(led4,GPIO.LOW)
    GPIO.output(ledl,GPIO.LOW)

    pygame.mixer.init()
    pygame.mixer.music.set_volume(1)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("sound1.mp3")
    pygame.mixer.music.play()

def led2_aan():
    "Deelnemer 2 heeft als eerste gedrukt"
    GPIO.output(led1,GPIO.LOW)
    GPIO.output(led2,GPIO.HIGH)
    GPIO.output(led3,GPIO.LOW)
    GPIO.output(led4,GPIO.LOW)
    GPIO.output(ledl,GPIO.LOW)

    pygame.mixer.init()
    pygame.mixer.music.set_volume(1)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("sound2.mp3")
    pygame.mixer.music.play()

def led3_aan():
    "Deelnemer 3 heeft als eerste gedrukt"
    GPIO.output(led1,GPIO.LOW)
    GPIO.output(led2,GPIO.LOW)
    GPIO.output(led3,GPIO.HIGH)
    GPIO.output(led4,GPIO.LOW)
    GPIO.output(ledl,GPIO.LOW)

    pygame.mixer.init()
    pygame.mixer.music.set_volume(1)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("sound3.mp3")
    pygame.mixer.music.play()

def led4_aan():
    "Deelnemer 4 heeft als eerste gedrukt"
    GPIO.output(led1,GPIO.LOW)
    GPIO.output(led2,GPIO.LOW)
    GPIO.output(led3,GPIO.LOW)
    GPIO.output(led4,GPIO.HIGH)
    GPIO.output(ledl,GPIO.LOW)

    pygame.mixer.init()
    pygame.mixer.music.set_volume(1)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("sound4.mp3")
    pygame.mixer.music.play()

def leds_uit():
    "Led geeft inputvraag aan"
    GPIO.output(led1,GPIO.LOW)
    GPIO.output(led2,GPIO.LOW)
    GPIO.output(led3,GPIO.LOW)
    GPIO.output(led4,GPIO.LOW)
    GPIO.output(ledl,GPIO.HIGH)

    pygame.mixer.init()
    pygame.mixer.music.set_volume(0.5)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("soundl.mp3")
    pygame.mixer.music.play()


def deelnemer1():
    led1_aan()
    while (True):
        if GPIO.input(knopl)==0:
            leds_uit()
            detect()

def deelnemer2():
    led2_aan()
    while (True):
        if GPIO.input(knopl)==0:
            leds_uit()
            detect()

def deelnemer3():
    led3_aan()
    while (True):
        if GPIO.input(knopl)==0:
            leds_uit()
            detect()

def deelnemer4():
    led4_aan()
    while (True):
        if GPIO.input(knopl)==0:
            leds_uit()
            detect()

def starttune():
    pygame.mixer.init()
    pygame.mixer.music.set_volume(0.6)  # zet waarde tussen 0.1 en 1
    pygame.mixer.music.load("opening.mp3")
    pygame.mixer.music.play()

def detect():
    while (True):
        if GPIO.input(knop1)==0:
            deelnemer1()
        if GPIO.input(knop2)==0:
            deelnemer2()
        if GPIO.input(knop3)==0:
            deelnemer3()
        if GPIO.input(knop4)==0:
            deelnemer4()


# ------- Hoofdprogramma ------- #

GPIO.output(led1,GPIO.HIGH)
GPIO.output(led2,GPIO.HIGH)
GPIO.output(led3,GPIO.HIGH)
GPIO.output(led4,GPIO.HIGH)
GPIO.output(ledl,GPIO.LOW)

print ("\033[1;1;1m,\033c")
print ("\033[1;33mKWIZZY - Quizprogramma voor 4 deelnemers/teams")
print ("==============================================\033[1;m")
print ("Programma is gestart en wacht op invoer\n")
print ("\nGebruik [Ctrl]-c om het programma te stoppen")

starttune()

# Alle leds bij start in de gewenste status
GPIO.output(led1,GPIO.LOW)
GPIO.output(led2,GPIO.LOW)
GPIO.output(led3,GPIO.LOW)
GPIO.output(led4,GPIO.LOW)
GPIO.output(ledl,GPIO.HIGH)

detect()
